diff -Naur --exclude=CVS --exclude=configs linux/hpc/prequest.c linux-openmosix/hpc/prequest.c
--- linux/hpc/prequest.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/prequest.c	2002-07-10 15:20:15.000000000 +0200
@@ -0,0 +1,807 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#include <linux/sched.h>
+#include <linux/hpc.h>
+#include <linux/slab.h>
+#include <linux/smp_lock.h>
+#include <linux/file.h>
+#include <asm/uaccess.h>
+#include <hpc/request.h>
+#include <hpc/routines.h>
+#include <hpc/protocol.h>
+#include <hpc/defs.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+
+int request_on_remote(struct prequest *);
+
+static inline void
+issue_request(struct prequest *pr, struct task_struct *to)
+{
+	sigset_t blocked;
+	register struct task_struct *p = current;
+	unsigned long flags;
+	DECLARE_WAITQUEUE(wait, p);
+
+	if(to->mosix.dflags & DFINISHED)
+	{
+		pr->rflags = PR_ERROR;
+		goto out;
+	}
+	pr->rflags = PR_WAITING;
+	init_waitqueue_head(&pr->waitq);
+	pr->rnext = to->mosix.prequest;
+	to->mosix.prequest = pr;
+	wake_up_mosix(to);
+	if(!p->sig)	/* can happen when calling from EXIT */
+	{
+		pr->rflags &= ~PR_WAITING;
+		goto out;
+	}
+	spin_lock_irqsave(&p->sigmask_lock, flags);
+	blocked = p->blocked;
+	siginitsetinv(&p->blocked, sigmask(SIGKILL));
+	if(p->sig->action[SIGTERM-1].sa.sa_handler == SIG_DFL)
+		p->blocked.sig[0] &= ~sigmask(SIGTERM);
+	if(p->sig->action[SIGINT-1].sa.sa_handler == SIG_DFL)
+		p->blocked.sig[0] &= ~sigmask(SIGINT);
+	if(p->sig->action[SIGQUIT-1].sa.sa_handler == SIG_DFL)
+		p->blocked.sig[0] &= ~sigmask(SIGQUIT);
+	if(p->sig->action[SIGHUP-1].sa.sa_handler == SIG_DFL)
+		p->blocked.sig[0] &= ~sigmask(SIGHUP);
+	recalc_sigpending(p);
+	spin_unlock_irqrestore(&p->sigmask_lock, flags);
+	add_wait_queue(&pr->waitq, &wait);
+	set_current_state(TASK_INTERRUPTIBLE);
+	while((pr->rflags == PR_WAITING) && !signal_pending(p))
+	{
+		unlock_mosix();
+		schedule();
+		set_current_state(TASK_INTERRUPTIBLE);
+		lock_mosix();
+	}
+	remove_wait_queue(&pr->waitq, &wait);
+	set_current_state(TASK_RUNNING);
+	spin_lock_irqsave(&p->sigmask_lock, flags);
+	p->blocked = blocked;
+	recalc_sigpending(p);
+	spin_unlock_irqrestore(&p->sigmask_lock, flags);
+	pr->rflags &= ~PR_WAITING;
+ out:
+	free_task_struct(to);
+}
+
+char *
+request_process_to_buf_arg(struct task_struct *p, char *buffer, int command, int arg)
+{
+	struct prequest *pr;
+	char *reply = buffer;
+
+	get_task_struct(p);
+	if(!(pr = kmalloc(sizeof(struct prequest), GFP_KERNEL)))
+	{
+		free_task_struct(p);
+		return(reply);
+	}
+	pr->command = command;
+	pr->param = arg;
+	pr->ereply = buffer;
+	pr->len = 0;
+	pr->reply = 0;
+	if(command == PR_PROCFS_TASK_MEM && pick_ps(p, pr))
+	{
+		reply = (char *)pr->reply;
+		kfree(pr);
+		free_task_struct(p);
+		return(reply);
+	}
+	lock_mosix();
+	issue_request(pr, p);
+	if(pr->rflags == PR_DONE)
+		reply = (char *)pr->reply;
+	if(pr->rflags & (PR_DONE|PR_ERROR))
+		kfree(pr);
+	unlock_mosix();
+	return(reply);
+}
+
+int
+request_process_arg2(struct task_struct *p, void *indata, int command, int arg, int arg2)
+{
+	struct prequest *pr;
+	int reply = -ENOMEM;
+
+	get_task_struct(p);
+	if(!(pr = kmalloc(sizeof(struct prequest), GFP_KERNEL)))
+	{
+		free_task_struct(p);
+		return(reply);
+	}
+	reply = -EIO;
+	pr->command = command;
+	pr->param = arg;
+	pr->param2 = arg2;
+	pr->ereply = indata;
+	pr->len = 0;
+	pr->reply = 0;
+	switch(command)
+	{
+	case PR_PROCFS_GET_ARG:
+	case PR_PROCFS_GET_ENV:
+	case PR_PROCFS_GET_STAT_PARTS:
+	case PR_PROCFS_GET_STATM:
+		if(pick_ps(p, pr))
+		{
+			reply = pr->reply;
+			kfree(pr);
+			free_task_struct(p);
+			return(reply);
+		}
+		break;
+#ifdef CONFIG_MOSIX_DFSA
+	case PR_DFSA_SYNCHRONIZE:
+		if(p->mosix.ps)
+		{
+			kfree(pr);
+			free_task_struct(p);
+			return(0);
+		}
+#endif /* CONFIG_MOSIX_DFSA */
+	}
+	lock_mosix();
+	issue_request(pr, p);
+	if(pr->rflags == PR_DONE)
+		reply = pr->reply;
+	if(pr->rflags & (PR_DONE|PR_ERROR))
+		kfree(pr);
+	else
+		reply = -EINTR;
+	unlock_mosix();
+	return(reply);
+}
+
+int
+request_on_local(struct prequest *pr)
+{
+	switch(pr->command)
+	{
+	case PR_PROCFS_TASK_MEM:
+		pr->reply = (long)(current->mm ?
+				   task_mem(current->mm, pr->ereply) : pr->ereply);
+		break;
+	case PR_PROCFS_GET_ENV:
+		pr->reply = proc_pid_environ(current, pr->ereply);
+		break;
+	case PR_PROCFS_GET_ARG:
+		pr->reply = proc_pid_cmdline(current, pr->ereply);
+		break;
+	case PR_PROCFS_GET_STAT_PARTS:
+		proc_get_stat_parts(current, current->mm,
+				    (struct proc_remote_stat_parts *)pr->ereply);
+		pr->reply = 0;
+		break;
+	case PR_PROCFS_GET_STATM:
+		pr->reply = proc_pid_statm(current, pr->ereply);
+		break;
+	case PR_PROCFS_GET_EXE:
+		pr->reply = (int)first_executable();
+		break;
+	case PR_PROCFS_MAP_INFO:
+		pr->reply = proc_list_maps((struct vmamaps *)pr->ereply,
+					   pr->param);
+		ref_mapped_files((struct vmamaps *)pr->ereply,
+				 pr->reply);
+		break;
+	case PR_PROCFS_MEM_READ:
+		pr->reply = access_process_vm(current,
+					      (unsigned long)pr->param, pr->ereply,
+					      pr->param2, 0);
+		break;
+	case PR_PROCFS_MEM_WRITE:
+		pr->reply = access_process_vm(current,
+					      (unsigned long)pr->param, pr->ereply,
+					      pr->param2, 1);
+		break;
+#ifdef CONFIG_MOSIX_DFSA
+	case PR_DFSA_SYNCHRONIZE:
+#endif /* CONFIG_MOSIX_DFSA */
+	case PR_PTRACE_NOT_TRACED:
+	case PR_PROCFS_UPDATE_TIMES:
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_GET_STACK_LONG:
+		pr->reply = get_stack_long(current, pr->param);
+		break;
+	case PR_PTRACE_PUT_STACK_LONG:
+		pr->reply = put_stack_long(current, pr->param,
+					   (unsigned long)pr->param2);
+		break;
+	case PR_PTRACE_GETREGS:
+		ptrace_getregs((unsigned long *)pr->ereply);
+		break;
+	case PR_PTRACE_SETREGS:
+		ptrace_putregs((unsigned long *)pr->ereply);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_PEEKUSER:
+		*((unsigned long *)pr->ereply) =
+			ptrace_peekuser(pr->param);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_POKEUSER:
+		ptrace_pokeuser(pr->param, pr->param2);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_CONT:
+		ptrace_cont(pr->param);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_SINGLE_STEP:
+		ptrace_single_step();
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_GETFPREGS:
+		ptrace_getfpregs((struct user_i387_struct *)pr->ereply);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_SETFPREGS:
+		ptrace_setfpregs((struct user_i387_struct *)pr->ereply);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_GETFPXREGS:
+		ptrace_getfpxregs(
+			(struct user_fxsr_struct *)pr->ereply);
+		pr->reply = 0;
+		break;
+	case PR_PTRACE_SETFPXREGS:
+		ptrace_setfpxregs(
+			(struct user_fxsr_struct *)pr->ereply);
+		pr->reply = 0;
+		break;
+	}
+	return(PR_DONE);
+}
+
+void
+free_unwanted_request(struct prequest *pr)
+{
+	struct file *filp;
+
+	if((pr->rflags & (PR_WAITING|PR_DONE|PR_ERROR)) == PR_DONE)
+		switch(pr->command)
+		{
+		case PR_PROCFS_GET_EXE:
+			filp = (struct file *)pr->reply;
+			if(filp)
+				fput(filp);
+			break;
+		}
+	kfree(pr);
+}
+
+void
+process_requests(void)
+{
+	register struct prequest *pr;
+	int res;
+
+	lock_mosix();
+	while((pr = current->mosix.prequest))
+	{
+		current->mosix.prequest = pr->rnext;
+		if(!(pr->rflags & PR_WAITING))
+		{
+			kfree(pr);
+			continue;
+		}
+		unlock_mosix();
+		pr->reply = 0;
+		if(current->mosix.dflags & DDEPUTY)
+			res = request_on_remote(pr);
+		else
+			res = request_on_local(pr);
+		lock_mosix();
+		pr->rflags |= res;
+		if(pr->rflags & PR_WAITING)
+			wake_up(&pr->waitq);
+		else
+		{
+			unlock_mosix();
+			free_unwanted_request(pr);
+			lock_mosix();
+		}
+	}
+	unlock_mosix();
+}
+
+void
+discard_requests(void)
+{
+	register struct prequest *pr;
+
+	lock_mosix();
+	while((pr = current->mosix.prequest))
+	{
+		current->mosix.prequest = pr->rnext;
+		if(pr->rflags & PR_WAITING)
+		{
+			pr->rflags |= PR_ERROR;
+			wake_up(&pr->waitq);
+		}
+		else
+		{
+			unlock_mosix();
+			free_unwanted_request(pr);
+			lock_mosix();
+		}
+	}
+	unlock_mosix();
+}
+
+int
+request_on_remote(struct prequest *pr)
+{
+	struct prequest_h p;
+	struct prequest_reply_h r;
+	void *snd;
+	int sndlen;
+	int err = 0;
+
+	p.command = pr->command;
+	p.param = pr->param;
+	p.param2 = pr->param2;
+	p.len = pr->len;
+	snd = NULL;
+	sndlen = 0;
+	switch(pr->command)
+	{
+	case PR_PROCFS_MEM_READ:
+		flush_read_cache();
+		break;
+	case PR_PROCFS_MEM_WRITE:
+		flush_ucache();
+		snd = pr->ereply;
+		sndlen = pr->param2;
+		break;
+#ifdef CONFIG_MOSIX_DFSA
+	case PR_DFSA_SYNCHRONIZE:
+		/* once we are here - we have already achieved
+		 * the purpose of synchronization!
+		 */
+		pr->reply = 0;
+		goto done;
+#endif /* CONFIG_MOSIX_DFSA */
+	case PR_PTRACE_SETREGS:
+		snd = pr->ereply;
+		sndlen = 17 * sizeof(long);
+		break;
+	case PR_PTRACE_SETFPREGS:
+		snd = pr->ereply;
+		sndlen = sizeof(struct user_i387_struct);
+		break;
+	case PR_PTRACE_SETFPXREGS:
+		snd = pr->ereply;
+		sndlen = sizeof(struct user_fxsr_struct);
+		break;
+		/* the following may be done locally */
+	case PR_PROCFS_GET_STAT_PARTS:
+	case PR_PROCFS_GET_STATM:
+	case PR_PROCFS_TASK_MEM:
+		if(pick_ps(current, pr))
+			goto done;
+		break;
+		/* the following read from user: */
+	case PR_PROCFS_GET_ARG:
+	case PR_PROCFS_GET_ENV:
+		if(pick_ps(current, pr))
+			goto done;
+		flush_read_cache();
+		break;
+	case PR_PROCFS_UPDATE_TIMES:
+		mosix_deputy_rusage(0);
+		pr->reply = 0;
+		goto done;
+	}
+	if(deputy_request(DEP_PREQUEST, &p, sizeof(p), snd, sndlen, 0,
+			  (void **)&r, -sizeof(r)) || r.error)
+	{
+		err = PR_ERROR;
+		goto done;
+	}
+	pr->reply = r.reply;
+	if(r.datalen > 0 && comm_copydata(pr->ereply, r.datalen, 0))
+		err = PR_ERROR;
+	else
+		switch(pr->command)
+		{
+		case PR_PROCFS_TASK_MEM:
+			pr->reply = (int)(pr->ereply + r.reply);
+			break;
+		case PR_PROCFS_GET_STAT_PARTS:
+			mosix_deputy_rusage(0);
+			break;
+		case PR_PROCFS_GET_ENV:
+		case PR_PROCFS_GET_ARG:
+		case PR_PROCFS_GET_STATM:
+		case PR_PTRACE_GET_STACK_LONG:
+		case PR_PTRACE_PUT_STACK_LONG:
+		case PR_PTRACE_GETREGS:
+		case PR_PTRACE_SETREGS:
+		case PR_PTRACE_PEEKUSER:
+		case PR_PTRACE_POKEUSER:
+		case PR_PTRACE_CONT:
+		case PR_PTRACE_SINGLE_STEP:
+		case PR_PTRACE_GETFPREGS:
+		case PR_PTRACE_SETFPREGS:
+		case PR_PTRACE_GETFPXREGS:
+		case PR_PTRACE_SETFPXREGS:
+		case PR_PROCFS_MEM_READ:
+		case PR_PROCFS_MEM_WRITE:
+			break;
+		case PR_PROCFS_MAP_INFO:
+			ref_mapped_files((struct vmamaps *)pr->ereply,
+					 pr->reply);
+			break;
+		case PR_PROCFS_GET_EXE:
+		{
+			struct file *filp = (struct file *)pr->reply;
+			if(filp)
+				get_file(filp);
+		}
+		break;
+		default:
+			printk("request on remote - unknown code\n");
+		}
+ done:
+	return(PR_DONE|err);
+}
+
+int
+remote_prequest(struct prequest_h *p)
+{
+	struct prequest_reply_h r;
+	char *buffer;
+	int err;
+	unsigned long data[17];
+	unsigned int allocated = 0;
+
+	r.error = r.datalen = 0;
+	switch(p->command)
+	{
+	case PR_PROCFS_TASK_MEM:
+	case PR_PROCFS_GET_ENV:
+	case PR_PROCFS_GET_ARG:
+	case PR_PROCFS_GET_STAT_PARTS:
+	case PR_PROCFS_GET_STATM:
+	case PR_PROCFS_MAP_INFO:
+	case PR_PROCFS_MEM_READ:
+	case PR_PTRACE_GETFPREGS:
+	case PR_PTRACE_GETFPXREGS:
+		if((buffer = (char *)__get_free_page(GFP_KERNEL)))
+			allocated = 1;
+		else
+		{
+			r.error = -ENOMEM;
+			buffer = NULL;
+		}
+		break;
+	case PR_PTRACE_GETREGS:
+	case PR_PTRACE_PEEKUSER:
+		buffer = (char *)data;
+		break;
+	default:
+		buffer = NULL;
+		break;
+	}
+	if(!r.error)
+		switch(p->command)
+		{
+		case PR_PROCFS_TASK_MEM:
+			r.datalen = r.reply = current->mm ?
+				task_mem(current->mm, buffer) - buffer : 0;
+			break;
+		case PR_PROCFS_GET_ENV:
+			r.datalen = r.reply = proc_pid_environ(current, buffer);
+			break;
+		case PR_PROCFS_GET_ARG:
+			r.datalen = r.reply = proc_pid_cmdline(current, buffer);
+			break;
+		case PR_PROCFS_GET_STAT_PARTS:
+			proc_get_stat_parts(current, current->mm,
+					    (struct proc_remote_stat_parts *)buffer);
+			r.reply = 0;
+			r.datalen = sizeof(struct proc_remote_stat_parts);
+			break;
+		case PR_PROCFS_GET_STATM:
+			r.datalen = r.reply = proc_pid_statm(current, buffer);
+			break;
+		case PR_PROCFS_GET_EXE:
+			r.reply = (int)first_executable();
+			break;
+		case PR_PROCFS_MAP_INFO:
+			r.datalen = r.reply = proc_list_maps(
+				(struct vmamaps *)buffer, p->param);
+			break;
+		case PR_PROCFS_MEM_READ:
+			r.datalen = r.reply = access_process_vm(current,
+								p->param, (void *)buffer, p->param2, 0);
+			break;
+		case PR_PROCFS_MEM_WRITE:
+			if(comm_recvdata((void **)&buffer))
+				r.reply = 0;
+			else
+			{
+				r.reply = access_process_vm(current, p->param,
+							    (void *)buffer, p->param2, 1);
+				comm_free(buffer);
+			}
+			break;
+		case PR_PTRACE_GET_STACK_LONG:
+			r.reply = get_stack_long(current, p->param);
+			break;
+		case PR_PTRACE_PUT_STACK_LONG:
+			r.reply = put_stack_long(current, p->param,
+						 (unsigned long)p->param2);
+			break;
+		case PR_PTRACE_GETREGS:
+			ptrace_getregs((unsigned long *)buffer);
+			r.datalen = 17 * sizeof(unsigned long);
+			r.reply = 0;
+			break;
+		case PR_PTRACE_SETREGS:
+			r.reply = 0;
+			if(!comm_recvdata((void **)&buffer))
+			{
+				ptrace_putregs((unsigned long *)buffer);
+				comm_free(buffer);
+			}
+			break;
+		case PR_PTRACE_PEEKUSER:
+			data[0] = ptrace_peekuser(p->param);
+			r.datalen = sizeof(unsigned long);
+			r.reply = 0;
+			break;
+		case PR_PTRACE_POKEUSER:
+			ptrace_pokeuser(p->param, p->param2);
+			r.datalen = r.reply = 0;
+			break;
+		case PR_PTRACE_CONT:
+			ptrace_cont(p->param);
+			r.datalen = r.reply = 0;
+			break;
+		case PR_PTRACE_NOT_TRACED:
+			current->ptrace = 0;
+			r.datalen = r.reply = 0;
+			break;
+		case PR_PTRACE_SINGLE_STEP:
+			ptrace_single_step();
+			r.datalen = r.reply = 0;
+			break;
+		case PR_PTRACE_GETFPREGS:
+			ptrace_getfpregs((struct user_i387_struct *)buffer);
+			r.datalen = sizeof(struct user_i387_struct);
+			r.reply = 0;
+			break;
+		case PR_PTRACE_SETFPREGS:
+			r.reply = 0;
+			if(!comm_recvdata((void **)&buffer))
+			{
+				ptrace_setfpregs(
+					(struct user_i387_struct *)buffer);
+				comm_free(buffer);
+			}
+			break;
+		case PR_PTRACE_GETFPXREGS:
+			ptrace_getfpxregs((struct user_fxsr_struct *)buffer);
+			r.datalen = sizeof(struct user_fxsr_struct);
+			r.reply = 0;
+			break;
+		case PR_PTRACE_SETFPXREGS:
+			r.reply = 0;
+			if(!comm_recvdata((void **)&buffer))
+			{
+				ptrace_setfpxregs(
+					(struct user_fxsr_struct *)buffer);
+				comm_free(buffer);
+			}
+			break;
+		}
+	err = comm_send(DEP_PREQUEST|REPLY, &r, sizeof(r),
+			r.datalen ? buffer : NULL, r.datalen, 0);
+	if(allocated)
+		free_page((unsigned long)buffer);
+	comm_free(p);
+	return(err);
+}
+
+void
+process_only_easy_requests(void)
+{
+	register struct prequest *pr, *prev, *next;
+
+	if(!current->mosix.ps)
+		return;
+	lock_mosix();
+	for(prev = NULL, pr = current->mosix.prequest ; pr ; )
+		switch(pr->command)
+		{
+#ifdef CONFIG_MOSIX_DFSA
+		case PR_DFSA_SYNCHRONIZE:
+			pr->reply = 0;
+			pr->rflags |= PR_DONE;
+			goto next_one;
+#endif /* CONFIG_MOSIX_DFSA */
+		case PR_PROCFS_GET_ARG:
+		case PR_PROCFS_GET_ENV:
+		case PR_PROCFS_TASK_MEM:
+		case PR_PROCFS_GET_STAT_PARTS:
+		case PR_PROCFS_GET_STATM:
+			pick_ps(current, pr);
+#ifdef CONFIG_MOSIX_DFSA
+		next_one:
+#endif /* CONFIG_MOSIX_DFSA */
+			next = pr->rnext;
+			if(prev)
+				prev->rnext = next;
+			else
+				current->mosix.prequest = next;
+			if(pr->rflags & PR_WAITING)
+				wake_up(&pr->waitq);
+			else
+				kfree(pr);
+			pr = next;
+			break;
+		default:
+			prev = pr;
+			pr = pr->rnext;
+		}
+	unlock_mosix();
+}
+
+/* Saved record structure:
+ * 1: args (null terminated)
+ * 2: env (null terminated)
+ * 3: task_mem (null terminated)
+ * 4: struct proc_remote_stat_parts (32 bytes at the moment)
+ * 5: statm output (null terminated)
+ * Below is an overkill estimate of 3+4+5:
+ */
+#define	MAX_REQ_FOR_STATS	350
+
+char *
+fill_common_ps_info(int *n)
+{
+	char *buffer = kmalloc(2*PAGE_SIZE+MAX_REQ_FOR_STATS, GFP_KERNEL);
+	char *e, *p;
+	struct task_struct *t = current;
+	int l1, l2, l3;
+
+	if(n)
+		*n = 0;
+	if(!buffer)
+		return(NULL);
+	e = buffer + (l1 = proc_pid_cmdline(t, buffer));
+	e += (l2 = proc_pid_environ(t, e));
+	e += (l3 = task_mem(t->mm, e) - e);
+	proc_get_stat_parts(t, t->mm, (struct proc_remote_stat_parts *)e);
+	e += sizeof(struct proc_remote_stat_parts);
+	e += proc_pid_statm(t, e);
+	*e++ = '\0';
+	if((p = kmalloc(e - buffer + 3*sizeof(short), GFP_KERNEL)))
+	{
+		((short *)p)[0] = l1;
+		((short *)p)[1] = l2;
+		((short *)p)[2] = l3;
+		memcpy(p + 3 * sizeof(short), buffer, l1 = e - buffer);
+	}
+	kfree(buffer);
+	if(n)
+		*n = p ? l1 + 3*sizeof(short) : 0;
+	return(p);
+}
+void
+store_common_ps_info(void)
+{
+	int n;
+	char *p;
+
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		flush_read_cache();
+		if(deputy_request(DEP_PSINFO, NULL, 0, NULL, 0, 0,
+				  (void **)&n, -sizeof(n)) || n <= 0)
+			return;
+		if(!(p = kmalloc(n, GFP_KERNEL)))
+		{
+			comm_flushdata(COMM_ALLDATA);
+			return;
+		}
+		if(comm_copydata(p, n, 0))
+			kfree(p);
+		else
+		{
+			lock_mosix();
+			current->mosix.ps = p;
+			unlock_mosix();
+		}
+	}
+	else
+	{
+		p = fill_common_ps_info(NULL);
+		lock_mosix();
+		current->mosix.ps = p;
+		unlock_mosix();
+	}
+	if(current->mosix.prequest)
+		process_only_easy_requests();
+}
+
+void
+stop_storing_common_ps_info(void)
+{
+	char *ps;
+
+	lock_mosix();
+	ps = current->mosix.ps;
+	current->mosix.ps = NULL;
+	unlock_mosix();
+	if(ps)
+		kfree(ps);
+}
+
+int
+pick_ps(struct task_struct *task, struct prequest *pr)
+{
+	register char *p, *t;
+	int l1, l2, l3;
+
+	lock_mosix();
+	if(!(p = task->mosix.ps))
+	{
+		unlock_mosix();
+		return(0);
+	}
+	l1 = *((short *)p)++;
+	l2 = *((short *)p)++;
+	l3 = *((short *)p)++;
+	switch(pr->command)
+	{
+	case PR_PROCFS_GET_STATM:
+		p += l1+l2+l3 + sizeof(struct proc_remote_stat_parts);
+		t = pr->ereply;
+		while(*p)
+			*t++ = *p++;
+		pr->reply = t - pr->ereply;
+		break;
+	case PR_PROCFS_GET_STAT_PARTS:
+		p += l1 + l2 + l3;
+		memcpy(pr->ereply, p,
+		       sizeof(struct proc_remote_stat_parts));
+		pr->reply = sizeof(struct proc_remote_stat_parts);
+		break;
+	case PR_PROCFS_TASK_MEM:
+		memcpy(pr->ereply, p + l1 + l2, l3);
+		pr->reply = (int)(pr->ereply + l3);
+		break;
+	case PR_PROCFS_GET_ENV:
+		memcpy(pr->ereply, p + l1, l2);
+		pr->reply = l2;
+		break;
+	case PR_PROCFS_GET_ARG:
+		memcpy(pr->ereply, p, l1);
+		pr->reply = l1;
+		break;
+	default:
+		panic("pick_ps: command");
+	}
+	pr->rflags |= PR_DONE;
+	unlock_mosix();
+	return(1);
+}
